import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int n = nextInt();
        int f = nextInt();
        if (f == 1) {
            long[] d = new long[n];
            for (int i = 0; i < n; i++) {
                d[i] = nextInt();
            }
            long[] max = new long[n];
            long mx = -1;
            for (int i = n - 1; i >= 0; i--) {
                if (d[i] > mx){
                    mx = d[i];
                }
                max[i] = mx;
                mx--;
            }
            for (int i = n - 1; i >= 0; i--) {
                if (d[i] > mx){
                    mx = d[i];
                }
                max[i] = mx;
                mx--;
            }
            long min = Integer.MAX_VALUE;
            int ind = -1;
            for (int i = 0; i < n; i++) {
                if (max[i] < min){
                    min = max[i];
                    ind = i + 1;
                }
            }
            pw.println(min + " " + ind);
            pw.close();
        } else {
            int m = nextInt();
            long x = nextInt();
            long y = nextInt();
            long z = nextInt();
            long[] copy = new long[m];
            for (int i = 0; i < m; i++) {
                copy[i] = nextInt();
            }
            long[] d = new long[max(m, n)];
            for (int i = 0; i < min(m, n); i++) {
                d[i] = copy[i];
            }
            for (int i = min(m, n); i < n; i++) {
                d[i] = ((x * d[i - 2] + y * d[i - 1] + z) % mod) + 1;
            }

        }
    }

    static BufferedReader br;
    static PrintWriter pw;
    static StringTokenizer st = new StringTokenizer("");
    static long mod = 1_000_000_000;


    public static boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}
