import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int n = nextInt();
        int q = nextInt();
        long[] a = new long[n];
        long[] b = new long[n];
//        Pair[] c = new Pair[q];
        long[] c = new long[q];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        for (int i = 0; i < n; i++) {
            b[i] = nextInt();
        }
        ArrayList<Drob> l = new ArrayList<>();
        for (int i = 0; i < min(n, q); i++) {
            for (int j = 0; j < min(q, n); j++) {
                l.add(new Drob(a[i], b[j]));
            }
        }
        Collections.sort(l, new DrobComp());
        for (int i = 0; i < q; i++) {
//            c[i] = new Pair(nextLong(), i);
            int ind = nextInt() - 1;
            long g = gcd(l.get(ind).a, l.get(ind).b);
            pw.println((l.get(ind).a / g) + " " + (l.get(ind).b / g));
        }
        pw.close();
    }


    static BufferedReader br;
    static PrintWriter pw;
    static StringTokenizer st = new StringTokenizer("");

    static ArrayList<Integer>[] g;
    static int[] col;
    static boolean[] used;

    static void dfs(int v, int p) {
        used[v] = true;
        if (p != -1) {
            col[v] = 1 - col[p];
        }
        for (int to : g[v]) {
            if (!used[to]) {
                dfs(to, v);
            }
        }
    }

    static long gcd(long a, long b) {
        while (b != 0) {
            a %= b;
            long h = a;
            a = b;
            b = h;
        }
        return a;
    }

    public static boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}

class Pair {
    long val;
    int ind;

    public Pair(long val, int ind) {
        this.val = val;
        this.ind = ind;
    }
}

class Drob {
    long a, b;

    public Drob(long a, long b) {
        this.a = a;
        this.b = b;
    }
}

class DrobComp implements Comparator<Drob> {

    @Override
    public int compare(Drob o1, Drob o2) {
        return Long.compare(o1.a * o2.b, o2.a * o1.b);
    }
}