import java.util.*;
import java.io.*;

public class Main {

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int n = nextInt();
        long []a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextLong();
        }
        long ans = 0;
        for(long l: a) ans += l;

        int shift = 0;
        int m = nextInt();
        for (int i = 0; i < m; i++) {
            int t = nextInt();
            if (t == 1){
                int ind = nextInt() - 1;
                int x = nextInt();
                long old = a[(ind - shift + n) % n];
                a[(ind - shift + n) % n] = x;
                ans = ans - old + x;
                pw.println(ans);
            }else{
                int k = nextInt();
                shift = (shift + k) % n;
                pw.println(ans);
            }
        }
        pw.close();
    }
    static BufferedReader br;
    static PrintWriter pw;
    static StringTokenizer st = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}
