import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int n = nextInt();
        int m = nextInt();
        int [] a = new int[n];
        int [] b = new int[m];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        for (int i = 0; i < m; i++) {
            b[i] = nextInt();
        }
        int l = min(n, m);
        int ans = 1;
        for (int i = l; i >= 2; i--) {
            for (int j = 0; j <= n - i; j++) {
                int[] cur = new int[i];
                System.arraycopy(a, j, cur, 0, i);
                boolean check = true;
                for (int k = 0; k < i / 2; k++) {
                    if (cur[k] != cur[i - k - 1]){
                        check = false;
                        break;
                    }
                }
                if (check){
                    ans = i;
                    break;
                }
            }
            if (ans != 1){
                break;
            }
        }
        pw.println(ans);
        pw.close();
    }

    static BufferedReader br;
    static PrintWriter pw;
    static StringTokenizer st = new StringTokenizer("");

    public static boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}