import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);

        int t = nextInt();
        for (int q = 0; q < t; q++) {
            long n = nextInt();
            long a = nextInt();
            long b = nextInt();
            long f_n = (a + b) / n;
            long max = (n + 1) * f_n + (((f_n - 1) * f_n) / 2) * n;
            long f_a = a / n;
            long f_b = b / n;
            long mod_a = n - (a % n);
            long mod_b = n - (b % n);
            max -= (((f_n - f_a) * ((f_n - f_a) - 1)) * n) / 2;
            max -= (((f_n - f_b) * ((f_n - f_b) - 1)) * n) / 2  ;
            max -= mod_a * (f_n - f_a);
            max -= mod_b * (f_n - f_b);
            pw.println(max);
        }
        pw.close();
    }

    static BufferedReader br;
    static PrintWriter pw;
    static StringTokenizer st = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (st.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            st = new StringTokenizer(s);
            if (st.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}
